// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package mutation;

public class Operators_Object {

 // Variable that holds the name of the last executed mutation
 public static String nameOfLastExecutedFunction = null;

 public interface functionOneParameter {
  Object run(Object input);
 }
 // Method 1: Replace by null object
 public static final functionOneParameter m1_replaceByNull = new functionOneParameter() {

  @Override
  public Object run(Object input) {
   nameOfLastExecutedFunction = "m1_replaceByNull";

   return null;
  }
 };

 // Method 2: Replace by empty object
 public static final functionOneParameter m2_replaceByEmpty = new functionOneParameter() {

  @Override
  public Object run(Object input) {
   nameOfLastExecutedFunction = "m2_replaceByEmpty";

   Object empty = new Object();
   return empty;
  }
 };

 // Method 3: Replace by object of different type
 public static final functionOneParameter m3_replaceByDifferentType = new functionOneParameter() {

  @Override
  public Object run(Object input) {
   nameOfLastExecutedFunction = "m3_replaceByDifferentType";

   // As a different type we use a object of this own class
   Operators_Object d = new Operators_Object();
   return d;
  }
 };

}